package com.hrsk.cloud.op.adapter.common.security;

import org.springframework.security.core.Authentication;

/**
 * @author: bianlanzhou
 * @create: 2024-10-14 17:48
 * @description: 身份验证信息
 **/
public class AuthenticationContextHolder {
    private static final ThreadLocal<Authentication> contextHolder = new ThreadLocal<>();

    public static Authentication getContext()
    {
        return contextHolder.get();
    }

    public static void setContext(Authentication context)
    {
        contextHolder.set(context);
    }

    public static void clearContext()
    {
        contextHolder.remove();
    }
}
