package com.hrsk.cloud.op.adapter.common.security;

import com.alibaba.fastjson2.JSON;
import com.hrsk.cloud.op.adapter.common.HttpUtils;
import com.hrsk.pangu.dto.Response;
import org.springframework.security.core.Authentication;
import org.springframework.security.web.authentication.logout.LogoutSuccessHandler;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * @author: bianlanzhou
 * @create: 2024-10-14 09:10
 * @description: 登出成功Hander实现类
 **/
@Component
public class LogoutSuccessHandlerImpl implements LogoutSuccessHandler {
    @Resource
    private HttpSecurityHelper httpSecurityHelper;
    @Override
    public void onLogoutSuccess(HttpServletRequest request, HttpServletResponse response, Authentication authentication) throws IOException, ServletException {
        String token = httpSecurityHelper.getToken(request);
        CurrentLoginUser currentLoginUser = httpSecurityHelper.getCurrentLoginUser(token);
        if (currentLoginUser != null) {
            String userName = currentLoginUser.getUsername();
            httpSecurityHelper.delLoginCache(currentLoginUser.getToken());
        }
        HttpUtils.renderString(response, JSON.toJSONString(Response.buildFailure("","")));
    }
}
