package com.hrsk.cloud.op.adapter.controller.egress;

import com.hrsk.cloud.op.client.api.EgressApiChannelService;
import com.hrsk.cloud.op.client.dto.EgressApiChannelDTO;
import com.hrsk.cloud.op.client.dto.command.EgressApiChannelUpsertCmd;
import com.hrsk.cloud.op.client.dto.command.EgressApiChannelQry;
import com.hrsk.pangu.dto.AntDMultiResponse;
import com.hrsk.pangu.dto.AntDPageResponse;
import com.hrsk.pangu.dto.PageResponse;
import com.hrsk.pangu.dto.SingleResponse;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @author: bianlanzhou
 * @create: 2024-10-23 11:36
 * @description: 通道controller
 **/
@RestController()
@RequestMapping("/egress/api/channel")
public class EgressApiChannelController {

    @Resource
    private EgressApiChannelService egressApiChannelService;
    /**
     * 创建
     * @param egressApiChannelUpsertCmd 创建通道
     * @return
     */
    @PutMapping("/create")
    public SingleResponse<Long> create(@RequestBody EgressApiChannelUpsertCmd egressApiChannelUpsertCmd){
        return null;
    }

    /**
     * 分页查询
     * @param egressApiChannelQry
     * @return
     */
    @GetMapping("/page")
    public AntDPageResponse<EgressApiChannelDTO> page(EgressApiChannelQry egressApiChannelQry){
        PageResponse<EgressApiChannelDTO> response = egressApiChannelService.page(egressApiChannelQry);
        return AntDPageResponse.of(response);
    }

    /**
     * 列表查询
     * @param egressApiChannelQry
     * @return
     */
    @GetMapping("/list")
    public AntDMultiResponse<EgressApiChannelDTO> list(EgressApiChannelQry egressApiChannelQry){
        return AntDMultiResponse.of(egressApiChannelService.list(egressApiChannelQry));
    }
}
