package com.hrsk.cloud.op.app.egress.executor;

import com.hrsk.cloud.op.client.dto.Operator;
import com.hrsk.cloud.op.client.dto.command.EgressApiChannelUpsertCmd;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity.EgressApiChannelDO;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity.EgressApiChannelHistoryDO;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.mapper.EgressApiChannelHistoryMapper;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.mapper.EgressApiChannelMapper;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * @author: bianlanzhou
 * @create: 2024-10-23 13:34
 * @description: 创建API通道EXE
 **/
@Component
public class EgressApiChannelCrtExe {
    @Resource
    private EgressApiChannelMapper egressApiChannelMapper;
    @Resource
    private EgressApiChannelHistoryMapper egressApiChannelHistoryMapper;

    /**
     * 执行 备份->插入->删除
     * @param egressApiChannelUpsertCmd CMD
     * @param operator 执行人
     * @return 主键
     */
    public Long execute(EgressApiChannelUpsertCmd egressApiChannelUpsertCmd, Operator operator){
        int version = 1;
        if(egressApiChannelUpsertCmd.getId()!=null){
            EgressApiChannelDO egressApiChannel = egressApiChannelMapper.selectById(egressApiChannelUpsertCmd.getId());
            egressApiChannelMapper.deleteById(egressApiChannelUpsertCmd.getId());
            egressApiChannelHistoryMapper.insert(EgressApiChannelHistoryDO.from(egressApiChannel));
            version = Integer.valueOf(egressApiChannel.getVersion())+1;
        }
        EgressApiChannelDO egressApiChannel = EgressApiChannelDO.from(egressApiChannelUpsertCmd,version+"",operator);
        egressApiChannelMapper.insert(egressApiChannel);
        return egressApiChannel.getId();
    }

}
