package com.hrsk.cloud.op.app.egress.executor;

import com.hrsk.cloud.op.client.dto.EgressApiChannelDTO;
import com.hrsk.cloud.op.client.dto.command.EgressApiChannelQry;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.dao.EgressApiChannelDao;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity.EgressApiChannelDO;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author: bianlanzhou
 * @create: 2024-10-21 15:29
 * @description: 接出API通道查询执行
 **/
@Component
public class EgressApiChannelQryExe {
    @Resource
    private EgressApiChannelDao egressApiChannelDao;
    /**
     * 执行
     * @param egressApiChannelQry CMD
     * @return 接出API列表
     */
    public List<EgressApiChannelDTO> execute(EgressApiChannelQry egressApiChannelQry){
        EgressApiChannelDO query = new EgressApiChannelDO();
        BeanUtils.copyProperties(egressApiChannelQry,query);
        List<EgressApiChannelDO> egressApiChannelDOS = egressApiChannelDao.selectEgressApiChannel(query);
        return egressApiChannelDOS.stream().map(egressApiChannelDO -> egressApiChannelDO.toDTO()).collect(Collectors.toList());
    }
}
