package com.hrsk.cloud.op.app.egress.executor;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.hrsk.cloud.op.domain.common.EgressApiErrorCodeEnum;
import com.hrsk.cloud.op.domain.egress.EgressApiStatusEnum;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity.EgressApiDO;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.mapper.EgressApiMapper;
import com.hrsk.pangu.tool.exception.BizException;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * @author: bianlanzhou
 * @create: 2024-11-03 17:31
 * @description: 删除接出API
 **/
@Component
public class EgressApiDelExe {
    @Resource
    private EgressApiMapper egressApiMapper;
    /**
     * 执行
     * @param id 主键
     */
    public void execute(Long id){
        EgressApiDO egressApiDO = egressApiMapper.selectById(id);
        if(!StringUtils.equals(EgressApiStatusEnum.DRAFT.getCode(),egressApiDO.getStatus())){
            throw new BizException(EgressApiErrorCodeEnum.API_STATUS_CAN_NOT_DELETE.getCode(),EgressApiErrorCodeEnum.API_STATUS_CAN_NOT_DELETE.getMessage());
        }
        Wrapper update = Wrappers.update().set("status",EgressApiStatusEnum.DELETE.getCode()).eq("id",id);
        egressApiMapper.update(update);
    }
}
