package com.hrsk.cloud.op.app.egress.executor;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.hrsk.cloud.op.client.dto.EgressApiLoanDTO;
import com.hrsk.cloud.op.client.dto.command.EgressApiLoanQry;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity.EgressApiLoanDO;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.mapper.EgressApiLoanMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author: bianlanzhou
 * @create: 2024-10-27 19:26
 * @description: 助贷API查询EXE
 **/
@Slf4j
@Component
public class EgressApiLoanQryExe {
    @Resource
    private EgressApiLoanMapper egressApiLoanMapper;

    /**
     * 执行
     * @param egressApiLoanQry CMD
     * @return 列表
     */
    public List<EgressApiLoanDTO> execute(EgressApiLoanQry egressApiLoanQry){
        EgressApiLoanDO query = EgressApiLoanDO.from(egressApiLoanQry);
        QueryWrapper<EgressApiLoanDO> queryWrapper = Wrappers
                .query(query);
        List<EgressApiLoanDO> egressApiLoanDOS = egressApiLoanMapper.selectList(queryWrapper);
        return egressApiLoanDOS.stream().map(egressApiLoanDO -> egressApiLoanDO.toDTO()).collect(Collectors.toList());
    }

}
