package com.hrsk.cloud.op.app.egress.executor;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.hrsk.cloud.op.client.dto.EgressApiDTO;
import com.hrsk.cloud.op.client.dto.command.EgressApiQry;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity.EgressApiDO;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.mapper.EgressApiMapper;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author: bianlanzhou
 * @create: 2024-10-21 15:29
 * @description: 接出API查询执行
 **/
@Component
public class EgressApiQryExe {
    @Resource
    private EgressApiMapper egressApiMapper;
    /**
     * 执行
     * @param egressApiQry CMD
     * @return 接出API列表
     */
    public List<EgressApiDTO> execute(EgressApiQry egressApiQry){
        EgressApiDO query = new EgressApiDO();
        BeanUtils.copyProperties(egressApiQry,query);
        QueryWrapper<EgressApiDO> queryWrapper = Wrappers
                .query(query);
        List<EgressApiDO> egressApiDOS = egressApiMapper.selectList(queryWrapper);
        return egressApiDOS.stream().map(egressApiDO -> egressApiDO.toDTO()).collect(Collectors.toList());
    }
}
