package com.hrsk.cloud.op.app.system;

import com.hrsk.cloud.op.app.system.executor.CaptchaCreateCmdExe;
import com.hrsk.cloud.op.client.api.AuthService;
import com.hrsk.cloud.op.client.dto.CaptchaDTO;
import com.hrsk.cloud.op.infrastructure.common.CaptchaTypeEnum;
import com.hrsk.cloud.op.infrastructure.repository.database.redis.RedisCache;
import com.hrsk.cloud.op.infrastructure.repository.database.redis.RedisKeyEnum;
import com.hrsk.pangu.dto.SingleResponse;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * @author: bianlanzhou
 * @create: 2024-10-11 11:46
 * @description: 认证服务
 **/
@Service
public class AuthServiceImpl implements AuthService {
    @Resource
    private CaptchaCreateCmdExe captchaCreateCmdExe;

    @Resource
    private RedisCache redisCache;

    @Override
    public SingleResponse<CaptchaDTO> imageCaptcha() {
        return SingleResponse.of(captchaCreateCmdExe.execute(CaptchaTypeEnum.IMAGE.getCode()));
    }

    @Override
    public SingleResponse<Boolean> validateCaptcha(String code, String uuid) {
        String captcha = redisCache.getCacheObject(RedisKeyEnum.CAPTCHA.getKey(uuid));
        return SingleResponse.of(StringUtils.equals(captcha,code));
    }

}
