package com.hrsk.cloud.op.app.system;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.hrsk.cloud.op.client.api.SysUserService;
import com.hrsk.cloud.op.client.dto.SysUserDTO;
import com.hrsk.cloud.op.client.dto.command.SysUserQry;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity.SysUserDO;
import com.hrsk.cloud.op.infrastructure.repository.database.mysql.mapper.SysUserMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * @author: bianlanzhou
 * @create: 2024-10-14 18:03
 * @description: 用户服务实现
 **/
@Service
public class SysUserServiceImpl implements SysUserService {
    @Resource
    private SysUserMapper sysUserMapper;

    @Override
    public List<SysUserDTO> querySysUser(SysUserQry sysUserQry) {
        SysUserDO query = new SysUserDO().from(sysUserQry);
        QueryWrapper<SysUserDO> queryWrapper = Wrappers
                .query(query);
        List<SysUserDO> sysUserDOList = sysUserMapper.selectList(queryWrapper);
        return sysUserDOList.stream().map(new Function<SysUserDO, SysUserDTO>() {
            @Override
            public SysUserDTO apply(SysUserDO sysUserDO) {
                return sysUserDO.toDTO();
            }
        }).collect(Collectors.toList());
    }
}
