package com.hrsk.cloud.op.client.api;

import com.hrsk.cloud.op.client.dto.EgressApiChannelDTO;
import com.hrsk.cloud.op.client.dto.command.EgressApiChannelUpsertCmd;
import com.hrsk.cloud.op.client.dto.command.EgressApiChannelQry;
import com.hrsk.pangu.dto.MultiResponse;
import com.hrsk.pangu.dto.PageResponse;
import com.hrsk.pangu.dto.SingleResponse;

/**
 * @author: bianlanzhou
 * @create: 2024-10-23 13:33
 * @description: 接出API通道服务
 **/
public interface EgressApiChannelService {
    /**
     * 创建
     * @param egressApiChannelUpsertCmd CMD
     * @return ID
     */
    SingleResponse<Long> create(EgressApiChannelUpsertCmd egressApiChannelUpsertCmd);

    /**
     * 分页查询
     * @param egressApiChannelQry 查询条件
     * @return 分页数据
     */
    PageResponse<EgressApiChannelDTO> page(EgressApiChannelQry egressApiChannelQry);

    /**
     * 列表查询
     * @param egressApiChannelQry 查询条件
     * @return 列表数据
     */
    MultiResponse<EgressApiChannelDTO> list(EgressApiChannelQry egressApiChannelQry);
}
