package com.hrsk.cloud.op.domain.common;

/**
 * @author: bianlanzhou
 * @create: 2024-10-15 10:10
 * @description: 验证类错误码枚举
 **/
public enum AuthErrorCodeEnum {

    ACCESS_DENIED("100009","您没有当前操作权限!"),
    CAPTCHA_NOT_MATCH("100008","验证码错误!"),
    NOT_LOGIN("100007","尚未登录，请先登录!"),
    OTP_NOT_MATCH("100006","验证码错误!"),
    USER_PASSWORD_RETRY_LIMIT_EXCEED("100005","用户密码重试超过最大次数!"),
    USER_HAS_DEACTIVATED("100004","用户已经被停用!"),
    USER_HAS_DELETED("100003","用户已经被删除!"),
    PASSWORD_NOT_MATCH("100002","用户名密码不匹配!"),
    USER_NOT_FOUND("100001","用户不存在!");

    private String code;

    private String message;
    /**
     * 前缀
     */
    private static final String PREFIX = "auth-";

    /**
     * 构造函数
     * @param code
     * @param message
     */
    AuthErrorCodeEnum(String code, String message) {
        this.code = code;
        this.message = message;
    }

    /**
     * 获取编码
     * @return 编码
     */
    public String getCode() {
        return PREFIX + code;
    }

    /**
     * 获取消息
     * @return 返回消息
     */
    public String getMessage() {
        return message;
    }
}
