package com.hrsk.cloud.op.domain.common;

/**
 * @author: bianlanzhou
 * @create: 2024-10-22 11:16
 * @description: 接出API错误编码枚举
 **/
public enum EgressApiErrorCodeEnum {
    API_NOT_EXIST("100006","api不存在!"),
    API_CHANNEL_CRT_FAIL("100005","api通道创建失败!"),
    API_STATUS_CAN_NOT_DELETE("100004","当前状态API无法删除!"),
    API_CODE_IS_DUPLICATE("100003","api编码已存在!"),
    API_NAME_IS_DUPLICATE("100002","api名称已存在!"),
    TECH_OWNER_NOT_EXIST("100001","技术负责人不存在!");

    private String code;

    private String message;
    /**
     * 前缀
     */
    private static final String PREFIX = "egress-";

    /**
     * 构造函数
     * @param code
     * @param message
     */
    EgressApiErrorCodeEnum(String code, String message) {
        this.code = code;
        this.message = message;
    }

    /**
     * 获取编码
     * @return 编码
     */
    public String getCode() {
        return PREFIX + code;
    }

    /**
     * 获取消息
     * @return 返回消息
     */
    public String getMessage() {
        return message;
    }
}
