package com.hrsk.cloud.op.infrastructure.repository.database.mysql.dao;

import org.apache.ibatis.annotations.Mapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author: bianlanzhou
 * @create: 2024-10-17 10:56
 * @description: 系统菜单DAO
 **/
@Repository
@Mapper
public interface SysMenuDao {
    /**
     * 通过ROLEID获取菜单权限字符串
     * @param roleId 角色ID
     * @return 菜单权限字符串
     */
    List<String> selectMenuPermsByRoleId(Long roleId);
    /**
     * 通过USERID获取菜单权限字符串
     * @param userId 用户ID
     * @return 菜单权限字符串
     */
    List<String> selectMenuPermsByUserId(Long userId);
}
