package com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.hrsk.cloud.op.client.dto.EgressApiChannelDTO;
import lombok.Data;
import org.springframework.beans.BeanUtils;

/**
 * @author: bianlanzhou
 * @create: 2024-10-23 14:25
 * @description: 表 egress_api_channel 数据对象。
 **/
@Data
@TableName("egress_api_channel_history")
public class EgressApiChannelHistoryDO extends BaseDO{
    /**
     * ID
     */
    private Long id;

    /**
     * 通道ID
     */
    private Long channelId;

    /**
     * egress_api的主键
     */
    private Long apiId;

    /**
     * api名称
     */
    private String apiName;

    /**
     * API类型
     */
    private String apiType;

    /**
     * 通道名称
     */
    private String channelName;

    /**
     * 通道编码
     */
    private String channelCode;

    /**
     * 请求配置
     */
    private byte[] requestConfig;

    /**
     * 备注
     */
    private String memo;
    /**
     * 版本
     */
    private String version;

    /**
     * 转化
     * @param egressApiChannelDO DO
     * @return this
     */
    public static EgressApiChannelHistoryDO from(EgressApiChannelDO egressApiChannelDO){
        EgressApiChannelHistoryDO egressApiChannelHistory = new EgressApiChannelHistoryDO();
        BeanUtils.copyProperties(egressApiChannelDO,egressApiChannelHistory);
        egressApiChannelHistory.setId(null);
        egressApiChannelHistory.setChannelId(egressApiChannelDO.getId());
        egressApiChannelHistory.setVersion(egressApiChannelDO.getVersion());
        return egressApiChannelHistory;
    }

    /**
     * 转DTO
     * @return
     */
    public EgressApiChannelDTO toDTO(){
        EgressApiChannelDTO egressApiChannelDTO = new EgressApiChannelDTO();
        BeanUtils.copyProperties(this, egressApiChannelDTO);
        return egressApiChannelDTO;
    }
}
