package com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.hrsk.cloud.op.client.dto.EgressApiDTO;
import com.hrsk.cloud.op.client.dto.Operator;
import com.hrsk.cloud.op.client.dto.command.EgressApiUpsertCmd;
import lombok.Data;
import org.springframework.beans.BeanUtils;

/**
 * @author: bianlanzhou
 * @create: 2024-10-21 14:48
 * @description: egress_api
 **/
@Data
@TableName("egress_api")
public class EgressApiDO extends BaseDO{
    /** ID **/
    private Long id;
    /**
     * API名称
     */
    private String apiName;
    /**
     * API编码
     */
    private String apiCode;
    /**
     * API类型
     */
    private String apiType;
    /**
     * 技术负责人ID
     */
    private Long techOwnerUserid;
    /**
     * 技术负责人
     */
    private String techOwnerUsername;

    /**
     * 备注
     */
    private String memo;
    /**
     * 状态
     */
    private String status;

    /**
     * 创建
     * @param egressApiUpsertCmd CMD
     * @param operator 操作人
     * @return EgressApiDO
     */
    public static final EgressApiDO from(EgressApiUpsertCmd egressApiUpsertCmd, Operator operator){
        EgressApiDO egressApiDO = new EgressApiDO();
        BeanUtils.copyProperties(egressApiUpsertCmd,egressApiDO);
        egressApiDO.setCreateUserid(operator.getId());
        egressApiDO.setCreateUsername(operator.getUsername());
        egressApiDO.setModifyUserid(operator.getId());
        egressApiDO.setModifyUsername(operator.getUsername());
        return egressApiDO;
    }

    /**
     * 转换
     * @return DTO
     */
    public EgressApiDTO toDTO(){
        EgressApiDTO egressApiDTO = new EgressApiDTO();
        BeanUtils.copyProperties(this,egressApiDTO);
        return egressApiDTO;
    }
}
