package com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.hrsk.cloud.op.client.dto.EgressApiLoanDTO;
import com.hrsk.cloud.op.client.dto.Operator;
import com.hrsk.cloud.op.client.dto.command.EgressApiLoanQry;
import lombok.Data;
import org.springframework.beans.BeanUtils;

/**
 * @author: bianlanzhou
 * @create: 2024-10-27 20:16
 * @description: 助贷API
 **/
@Data
@TableName("egress_api_loan")
public class EgressApiLoanDO extends BaseDO{
    /**
     * ID
     */
    private Long id;
    /**
     * API主键
     */
    private Long apiId;
    /**
     * 是否撞库
     */
    private String checkinto;
    /**
     * 商户ID
     */
    private Long merchantId;
    /**
     * 集成系统
     */
    private String integrationSystem;

    /**
     * 转化
     * @param egressApiLoanDTO DRO
     * @param operator 操作人
     * @return
     */
    public static EgressApiLoanDO from(EgressApiLoanDTO egressApiLoanDTO, Operator operator){
        EgressApiLoanDO egressApiLoan = new EgressApiLoanDO();
        BeanUtils.copyProperties(egressApiLoanDTO,egressApiLoan);
        egressApiLoan.setCreateUserid(operator.getId());
        egressApiLoan.setCreateUsername(operator.getUsername());
        egressApiLoan.setModifyUserid(operator.getId());
        egressApiLoan.setModifyUsername(operator.getUsername());
        return egressApiLoan;
    }

    /**
     * 转化
     * @param egressApiLoanQry QRT
     * @return DO
     */
    public static EgressApiLoanDO from(EgressApiLoanQry egressApiLoanQry){
        EgressApiLoanDO egressApiLoanDO = new EgressApiLoanDO();
        BeanUtils.copyProperties(egressApiLoanQry,egressApiLoanDO);
        return egressApiLoanDO;
    }

    /**
     * 转化
     * @return DTO
     */
    public EgressApiLoanDTO toDTO(){
        EgressApiLoanDTO egressApiLoanDTO = new EgressApiLoanDTO();
        BeanUtils.copyProperties(this,egressApiLoanDTO);
        return egressApiLoanDTO;
    }
}
