package com.hrsk.cloud.op.infrastructure.repository.database.mysql.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.hrsk.cloud.op.client.dto.SysUserDTO;
import com.hrsk.cloud.op.client.dto.command.SysUserQry;
import lombok.Data;
import org.springframework.beans.BeanUtils;

import java.util.List;

/**
 * @author: bianlanzhou
 * @create: 2024-10-14 18:08
 * @description: 系统用户表 sys_user
 **/
@Data
@TableName("sys_user")
public class SysUserDO extends BaseDO{

    private static final long serialVersionUID = 1L;
    /**
     * 主键
     */
    private Long id;
    /**
     * 用户名
     */
    private String username;
    /**
     * 用户昵称
     */
    private String nickName;
    /**
     * 密码
     */
    private String password;
    /**
     * 部门ID
     */
    private Long deptId;
    /**
     * otp密钥
     */
    private String otpSecret;
    /**
     * 所属部门
     */
    @TableField(exist = false)
    private SysDeptDO dept;

    /** 角色对象 */
    @TableField(exist = false)
    private List<SysRoleDO> roles;

    /**
     * 是否ADMIN
     * @return 是否ADMIN
     */
    public boolean isAdmin()
    {
        return id != null && 1L == id;
    }
    /**
     * 转换
     * @param sysUserQry 查询条件
     * @return
     */
    public SysUserDO from(SysUserQry sysUserQry){
        BeanUtils.copyProperties(sysUserQry,this);
        return this;
    }

    /**
     * 转换DTO
     * @return DTO
     */
    public SysUserDTO toDTO(){
        SysUserDTO dto = new SysUserDTO();
        BeanUtils.copyProperties(this,dto);
        return dto;
    }

}
