package com.hrsk.cloud.op.infrastructure.repository.database.redis;

import lombok.Getter;

/**
 * @author: bianlanzhou
 * @create: 2024-10-11 10:56
 * @description: redis key 枚举
 **/
@Getter
public enum RedisKeyEnum {
    CAPTCHA("captcha:%s","图片验证码"),
    PWD_ERR_CNT("pwd_err_cnt:%s","密码验证错误次数"),
    LOGIN_TOKEN_KEY("login_tokens:%s","登录token的key");
    /**
     * 编码
     */
    private String code;
    /**
     * 描述
     */
    private String desc;

    /**
     * 构造函数
     * @param code 编码
     * @param desc 描述
     */
    RedisKeyEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    /**
     * 获取KEY
     * @param args 参数
     * @return key
     */
    public String getKey(Object... args){
        return String.format(code,args);
    }

}
