package com.hrsk.cloud.op;

import lombok.extern.slf4j.Slf4j;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.ApplicationContext;

@Slf4j
@SpringBootApplication
@MapperScan(basePackages = {"com.hrsk.cloud.op.infrastructure.repository.database.mysql"})
public class Application {
    /**
     * main函数
     * @param args 参数
     */
    public static void main(String[] args) {
        launch(args);
    }

    /**
     * 引导方法
     * @param args 参数
     */
    private static void launch(String[] args){
        log.info("Begin to start Spring Boot Application ......");
        long startTime = System.currentTimeMillis();
        ApplicationContext ac = SpringApplication.run(Application.class, args);
        long endTime = System.currentTimeMillis();
        log.info("Spring Boot Application has been started, Time used: "+ (endTime - startTime) + "ms" );
    }


}
